<?php

class rentPress_ShortCodes_Units extends rentPress_ShortCodes_Base 
{
    public function handleShortcode($atts, $content = '') 
    {
        global $wpdb, $rentPress_Service;

        $attributes = shortcode_atts( array(
            'property_code' => false,
          	'fp_id' => false
        ), $atts );

        // Units Query
        $queryUnitsArgs=[];

        if (isset($attributes['property_code']) && $attributes['property_code'] != false) {
        	$queryUnitsArgs['prop_code']=$attributes['property_code'];
        }

        if ( isset($attributes['fp_id']) && $attributes['fp_id'] != false ) {
        	$queryUnitsArgs['fpID']=$attributes['fp_id'];
        }

        $queryUnits=new rentPress_Units_Query($queryUnitsArgs);

        $queriedUnits=$queryUnits->run_query();

        // Gathering Rent Terms Available
        $distinctTermRents=[];

        $unitsTermRents=array_filter(
        	array_map(
        		function($unit) {
        			return $unit->Rent->TermRent;
        		}, 
        		$queriedUnits
        	), 
        	function($termRents) {
        		return is_array($termRents) || is_array($termRents);
    	    }
    	);

    	foreach ($unitsTermRents as $unitTermRents) {
			foreach ($unitTermRents as $termRent) {
				$distinctTermRents[]=$termRent->Term;    			
			}
    	}

    	$distinctTermRents=array_unique($distinctTermRents);

    	// Template
        ob_start();

        include __DIR__.'/Units_Template.php';

        return ob_get_clean();
    }
}