<div class="shortcode-units">
	<?php if (count($queriedUnits) == 0) : ?>

		<div class="no-units-response">
			<h2>We're sorry!</h2>
			<div class="no-units-response-message">
				<b>There are currently no available apartments with this floor plan.</b> 
				Please <a href="<?php echo get_permalink($PropertyOfFloorplan); ?>">visit the main property page</a> to review other floor plans, or <a href="/communities">visit the advanced search page</a> to browse our full property listing.
			</div>
		</div>

	<?php else : ?>

		<div class="unit-table-wrap">	
			<header>
				<form name="filter-form">
					<?php if (count($distinctTermRents)) : ?>
						<select name="rentTerm" onchange="rpShortcodeUnitTableRender();">
							<option value="">Choose Lease Term</option>
							<?php foreach ($distinctTermRents as $termRent) : ?>
								<option value="<?php echo $termRent; ?>"><?php echo $termRent; ?> Months</option>
							<?php endforeach; ?>
						</select>
					<?php endif; ?>

					<input type="date" name="moveInDate" onchange="rpShortcodeUnitTableRender()">
				</form>
			</header>

			<table class="stack units-table">
				<thead>
					<tr>
						<th>Unit</th>
						<th>Price / Mo</th>
						<th>SQ. FT.</th>
						<th>Availablity</th>
						<th>Action</th>
					</tr>
				</thead>

				<tbody>
					<?php foreach ($queriedUnits as $unit) : $Unit = $rentPress_Service['unit_meta']->fromUnit($unit); ?>
						<tr data-unit-code="<?php echo $unit->Identification->UnitCode; ?>" data-unit-available-on="<?php echo $unit->Information->AvailableOn; ?>">
							<td><?php echo $unit->Information->Name; ?></td>
							<td 
								data-is-price
								data-defualt-rent="<?php echo $Unit->rent(); ?>"
								data-rent-terms="<?php echo esc_attr(json_encode((array)$unit->Rent->TermRent)); ?>">
								<?php echo $Unit->rent(); ?>
							</td>
							<td><?php echo $unit->SquareFeet->Max; ?></td>
							<td>
								<?php 
									if ($unit->Information->isAvailable) {
										echo "Available Now";
									}
									else {
										echo "Available ". $unit->Information->AvailableOn;
									}
								?>	
							</td>
				      		<td>
				      			<a href="#" class="button">Request Info</a>
				      			<a href="<?php echo $unit->Information->AvailabilityURL; ?>" class="button alt-btn">Apply Now <i class="fa fa-angle-double-right"></i></a>
				      		</td>
						</tr>
					<?php endforeach; ?>
				</tbody>
			</table>
		</div>

	<?php endif; ?>

</div>